"""
This module defines the ``%explain`` IPython magic.

"""

import sys

from IPython.core.magic import Magics, magics_class, line_magic

from ollama import chat
from ollama import ChatResponse


@magics_class
class LLMMagics(Magics):
    @line_magic
    def explain(self, line):
        if not line:
            line = sys.last_value

        stream: ChatResponse = chat(
            model="llama3.2:1b",
            stream=True,
            messages=[
                {
                    "role": "user",
                    "content": f"""
                        Briefly explain what this is: {line}.
                        Changes are it was generated by python code.
                        Assume you response is going to be used during a debugging session.
                        """,
                },
            ],
        )
        for chunk in stream:
            print(chunk["message"]["content"], end="", flush=True)
